<?php 
/**
 * SourceMessageTooltip displays a tooltip that shows
 * the category and the default translate message when the user click on the text
 * 
 */
/**
 * Copyright (c) 2012 David Soyez
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *  
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *  
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 *
 * @author David Soyez <david.soyez@yiiframework.fr>
 * @link http://www.yiiframework.com/extension
 * @copyright Copyright &copy; 2012 yiiframework.fr
 * @license http://www.opensource.org/licenses/mit-license.php
 * @version 0.1
 * @package SourceMessageTooltip
 * @since 0.1
 */
class SourceMessageTooltip extends CWidget
{
	protected $is_registered;
	public $role;

	/**
	 * @brief register core and qtip js needed files
	 * @param scriptName string the qtip file name
	 */
	protected function registerScript() 
	{
		if($this->is_registered == TRUE)
			return;
		$cs = Yii::app()->clientScript;
		$cs->registerCoreScript('jquery');
		$assets = Yii::app()->extensionPath. DIRECTORY_SEPARATOR.'SourceMessageTooltip'.DIRECTORY_SEPARATOR.'assets';
		$aUrl = Yii::app()->getAssetManager()->publish($assets);
		$cs->registerScriptFile($aUrl.'/sourcemessagetooltip.js');
		$cs->registerCssFile($aUrl.'/sourcemessagetooltip.css');
		
		$this->is_registered = TRUE;
	}
		
	/**
	 * Receives a messages call from Yii::t()
	 * 
	 */
	public function t($category,$message,$params,$source,$language,$translated)
	{
		if($this->role != NULL AND Yii::app()->user->checkAccess($this->role) == FALSE)
			return FALSE;
			
		$this->registerScript();
		
		$orignal = array(
			'category'	=> $category,
			'message'	=> $message,
		);
		
		Yii::app()->clientScript->registerScript(__CLASS__.uniqid(), "SourceMessageTooltip.translations[".CJavaScript::encode($translated)."] = ".CJavaScript::encode($orignal).';' );		
	
		return TRUE;
	}		

}